// ===================================================================
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include "types-and-constants.hh"
// ===================================================================



// ===================================================================
int
main () {

  bool done = false;
  do {

    reference_record_s record;
    char buffer[BUFFER_SIZE];
    char* read_result = fgets(buffer, BUFFER_SIZE, stdin);
    assert(read_result != NULL);

    int parse_result;
    record.tag = buffer[0];
    unsigned short int temp_length;
    if (record.tag != TAG_END_OF_TRACE) {
 
      parse_result = sscanf(&buffer[2],
			    "%qx %hx %lx %lx",
			    &record.timestamp,
			    &temp_length,
			    &record.context_ID,
			    &record.virtual_address);
      assert(parse_result == 4);
      record.length = (unsigned char)temp_length;

    }

    size_t write_result = fwrite(&record,
				 sizeof(record),
				 1,
				 stdout);
    assert(write_result == 1);

    if (record.tag == TAG_END_OF_TRACE) {
      done = true;
    }

  } while (!done);

  // Exit successfully.
  return 0;

} // main
// ===================================================================
